﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SunyruruMabangjin
{
    public class MabangjinBy4 : MabangjinBase
    {
        /// <summary>
        /// 인자있는 생성자
        /// </summary>
        /// <param name="size">마방진크기</param>
        public MabangjinBy4(int size)
        {
            SetSize(size);
            Init();
        }

        /// <summary>
        /// 기본생성자
        /// </summary>
        public MabangjinBy4()
            : this(4)
        {
        }

        ~MabangjinBy4()
        {
        }

        public override void Make()
        {
            int x;
            int y;

            int qSize = Size / 4;

            for (int i = 0; i < Size * Size; i++)
            {
                x = i / Size;
                y = i % Size;

                if ((x / qSize == y / qSize) || (x / qSize + y / qSize + 1 == 4))
                    Data[x, y] = i + 1;
                else
                    Data[Size - x - 1, Size - y - 1] = i + 1;
            }
        }
    }
}
