﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SunyruruMabangjin
{
    public class MabangjinMain
    {
        private IMabangjinBase mbj;
        internal IMabangjinBase IMabangjinBase
        {
            get { return this.mbj; }
            set { this.mbj = value; }
        }

        public static void Main(string[] args)
        {
            MabangjinMain mbm = new MabangjinMain();

            Console.Write("출력하고 싶은 마방진의 크기를 입력하세요 : ");
            int size = int.Parse(Console.ReadLine());

            try
            {
                mbm.mbj = Switcher(size);
                mbm.mbj.Make();
                mbm.mbj.Print();
                mbm.mbj.Check();
            }
            catch (Exception ee) { Console.WriteLine(ee.Message); }
        }

        public static MabangjinBase Switcher(int n)
        {
            MabangjinBase mbj;

            // 홀수 마방진
            if (n % 2 == 1)
                mbj = new MabangjinOdd(n);
            else if (n % 4 == 0)
                mbj = new MabangjinBy4(n);
            else
                throw new Exception(string.Format("{0} 크기의 마방진은 생성할 수 없습니다.", n));

            return mbj;
        }
    }
}
